/*
 *    System Name : 菑͔FVXe
 *    Module Name : eLXg_v[eBeB CGg[
 *
 *       f[^eLXg_v[eBeB
 *
 *
 */
#include  <stdio.h>
#include  <stdlib.h>
#include  "hand.h"

char  dumpline[80];
char  buffer[32768];

struct _lines  lines;		/* f[^̊ǗƋL^[N */

usage()
{
	fprintf(stderr, "Usage : handump [-d/p [<file name>]] [-r <file name>]\n");
	fprintf(stderr, "  Ff[^t@CeLXg_v/tϊ\n");
	fprintf(stderr, "   -d [file] eLXg_v\n");
	fprintf(stderr, "   -r [file] eLXg_vꂽf[^tϊ\n");
	fprintf(stderr, "   -p [file] PC98 AZu_v\n");
}

main(int argc, char **argv)
{
	int  mode;
	char *fname;

	/* wvbZ[W */
	if (argc < 2) {
		usage();
		exit(0);
	}

	/* IvVp[^ǂݍ */
	{
		char *ap = argv[1];
		if (*ap != '-') {
			fprintf(stderr, "IvVw肳ĂȂ\n");
			usage();
			exit(0);
		}
		mode = *(++ap);
	}

	/* t@Cݒ */
	fname = argv[2];
		
	/* [hECg */
	switch (mode) {
	  case 'd' :
	  case 'D' :
	  case 'p' :
	  case 'P' :
		/* f[^ */
		{
			FILE *fp;
			if (fp = fopen("hand.dat", "rb")) {
				fread(buffer, 1, 32768, fp);
				fclose(fp);
				match_data_load(buffer);
			}
		}

		/* t@C_vo */
		{
			FILE *fp;
			if (argc >= 3) {
				if (fp = fopen(fname, "w")) {
					if (mode == 'p' || mode == 'P') {
						match_pcasm(fp);
					} else {
						match_dump(fp);
					}
					fclose(fp);

				} else {
					fprintf(stderr, "_vt@C߂Ȃ\n");
					usage();
					exit(0);
				}
			} else {
				fp = stdout;
				if (mode == 'p' || mode == 'P') {
					match_pcasm(fp);
				} else {
					match_dump(fp);
				}
			}
		}
		break;

	  case 'r' :
	  case 'R' :
		/* t@C_v */
		{
			FILE *fp;
			if (fp = fopen(fname, "r")) {
				while (!feof(fp)) {
					fgets(dumpline, 80, fp);
					match_load(*dumpline);
				}
				fclose(fp);
			} else {
				fprintf(stderr, "_vt@Cǂݍ߂Ȃ\n");
				exit(0);
			}
		}


		/* f[^obNAbv */
		{
			FILE *fp;
			if (fp = fopen("hand.res", "r")) {
				fclose(fp);
				unlink("hand.res");
			}
			if (fp = fopen("hand.dat", "r")) {
				fclose(fp);
				rename("hand.dat", "hand.res");
			}
		}
		/* f[^o */
		{
			FILE *fp;
			int  size;
			if (fp = fopen("hand.dat", "wb")) {
				size = match_data_save(buffer);
				fwrite(buffer, 1, size, fp);
				fclose(fp);
			}
		}

		break;

	  default:
		fprintf(stderr, "IvV̎w肪܂Ă\n");
		usage();
		exit(0);
	}

	match_stat();
}


/*
 *   p^[f[^vf[hZ[uǗ
 *
 */

dump_start(FILE *fp, int n)
{
	fprintf(fp,"S %d\n", n);
}
load_start()
{
	int  n;
	sscanf(dumpline+2,"%d", &n);
	return n;
}
dump_code(FILE *fp, word code)
{
	if (code >= 0x100) {
		fprintf(fp, "L%c%c\n", code>>8, code & 255);
	} else {
		fprintf(fp, "L%c\n", code);
	}
}
load_code()
{
	word code;
	unsigned char c = *(dumpline+1);
	if (iskanji(c)) {
		unsigned char c2 = *(dumpline+2);
		code = c * 256 + c2;
	} else {
		code = c;
	}
	return code;
}


dump_segment(FILE *fp, struct _eval *ref)
{
	fprintf(fp, "D\t%d,%d,%d,%d, %d,%d, %d,%d\n",
			ref->dir, ref->rot, ref->min, ref->max, ref->hx, ref->hy, ref->len, ref->lft);
}
load_segment(struct _eval *ref)
{
	int d1,d2,d3,d4,d5,d6,d7,d8;
	sscanf(dumpline+2, "%d,%d,%d,%d, %d,%d, %d,%d",
			&d1,&d2,&d3,&d4,&d5,&d6,&d7,&d8);
	ref->dir = d1;
	ref->rot = d2;
	ref->min = d3;
	ref->max = d4;
	ref->hx = d5;
	ref->hy = d6;
	ref->len = d7;
	ref->lft = d8;
}
	
dump_close(FILE *fp)
{
	fprintf(fp, "C\n");
}



/*
 *
 *   }b`f[^eLXg_v
 */

struct  _eval_table_n {
	word         code;
	struct _eval eval[0];
};

extern  void  *match_table[];

struct  _eval_table_n *match_sort_table[256];
match_cmp(void *arg1, void *arg2)
{
	struct  _eval_table_n **ap1 = (struct  _eval_table_n **)arg1;
	struct  _eval_table_n **ap2 = (struct  _eval_table_n **)arg2;
	return (*ap1)->code - (*ap2)->code;
}
match_sort(int max)
{
	qsort(match_sort_table, max, sizeof(struct  _eval_table_n *), match_cmp);
}

match_dump(FILE *fp)
{
	short  n, c, i, j;
	struct  _eval_table_n  *etp;

	for (n = 1; n <= 15; n++) {
		etp = (struct  _eval_table_n *)match_table[n];
		c = 0;
		while (etp->code) {
			match_sort_table[c++] = etp;
			etp = (struct _eval_table_n *)
			  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*n);
		}

		match_sort(c);

		dump_start(fp, n);
		for (i = 0; i < c; i++) {
			etp = match_sort_table[i];
			dump_code(fp, etp->code);
			for (j = 0; j < n; j++) {
				dump_segment(fp, &etp->eval[j]);
			}
		}

		dump_close(fp);
	}
}

match_load(char cmd)
{
	static short  n;
	static struct  _eval_table_n  *etp;
	static struct _eval *ref;

	switch(cmd) {
	  case 'S' :
		n = load_start();
		etp = (struct  _eval_table_n *)match_table[n];
		break;
	  case 'L' :
		etp->code = load_code();
		ref = etp->eval;
		etp = (struct _eval_table_n *)
		  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*n);
		break;
	  case 'D' :
		load_segment(ref++);
		break;
	  case 'C' :
		break;
	}
}


match_stat()
{
	short  n,c;
	long   l,s,t;
	struct  _eval_table_n  *etp;

	t = 0;
	for (n = 1; n <= 15; n++) {
		etp = (struct  _eval_table_n *)match_table[n];
		s = sizeof(struct _eval_table_n) + sizeof(struct _eval)*n;
		c = 0;
		while (etp->code) {
			c++;
			etp = (struct _eval_table_n *)((long)etp + s);
		}
		
		printf("%d : %d (%d) = %d\n", n, c, s, c*s);
		t += c*s;
	}
	printf("total %d\n", t);
}


/*
 *  PC98 p_vAZuo
 */

static	inline  int
  _IOCSd1(char no, int data)
{
	register int res asm("d0");
	register int d asm("d1");
	res = no;
	d = data;
	asm volatile("trap\t#15":"=g"(res):"g"(res),"g"(d));
	return res;
}
static inline	SftJis (int code)	{return _IOCSd1((char)0xa0,code);}


pcasm_head(FILE *fp)
{
	fprintf(fp,"HAND_SEG_HEAD:\n");
	fprintf(fp,"\tDW\t0,SEGDAT_1,SEGDAT_2,SEGDAT_3\n");
	fprintf(fp,"\tDW\tSEGDAT_4,SEGDAT_5,SEGDAT_6,SEGDAT_7\n");
	fprintf(fp,"\tDW\tSEGDAT_8,SEGDAT_9,SEGDAT_10,SEGDAT_11\n");
	fprintf(fp,"\tDW\tSEGDAT_12,SEGDAT_13,SEGDAT_14,SEGDAT_15\n\n");
}
pcasm_start(FILE *fp, int n)
{
	fprintf(fp,"SEGDAT_%d:\n", n);
}
pcasm_code(FILE *fp, word code)
{
	fprintf(fp, "\tDW\t%04.4XH", SftJis(code));
	if (code >= 0x100) {
		fprintf(fp, "\t\t; %c%c\n", code>>8, code & 255);
	} else {
		fprintf(fp, "\t\t; %c\n", code);
	}
}

pcasm_segment(FILE *fp, struct _eval *ref)
{
	fprintf(fp, "\tDB\t%d,%d,%d,%d, %d,%d, %d,%d\n",
			ref->dir, ref->rot, ref->min, ref->max, ref->hx, ref->hy, ref->len, ref->lft);
}
pcasm_close(FILE *fp)
{
	fprintf(fp, "\tDW\t0\n");
}



/*
 *
 *   PC98 p }b`f[^eLXg_v
 */

match_pcasm(FILE *fp)
{
	short  n, c, i, j;
	struct  _eval_table_n  *etp;

	pcasm_head(fp);

	for (n = 1; n <= 15; n++) {
		etp = (struct  _eval_table_n *)match_table[n];
		c = 0;
		while (etp->code) {
			match_sort_table[c++] = etp;
			etp = (struct _eval_table_n *)
			  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*n);
		}

		match_sort(c);

		pcasm_start(fp, n);
		for (i = 0; i < c; i++) {
			etp = match_sort_table[i];
			pcasm_code(fp, etp->code);
			for (j = 0; j < n; j++) {
				pcasm_segment(fp, &etp->eval[j]);
			}
		}

		pcasm_close(fp);
	}
}

