/*
 *    System Name : 菑͔FVXe
 *    Module Name : Ǘ
 *
 *       f[^̊ǗƓp[^̌vZTu[`pbP[W
 *
 *
 */
#include  "hand.h"

#ifdef AEgC

  f[^̊ǗƓp[^̌vZTu[`

  lines_clear();
  lines_dir_culc();
  lines_dir_next();
  lines_eval();
  lines_minmax();

extern  lines_clear();
/*
 *  f[^̊ǗƋL^[NB
 */

extern  lines_dir_culc(Cood pp, Cood np);
/*
 * _Ԃ̕p[^Zo
 * args:
 *   pp (AH,AL) : n_(x,y)
 *   np (BH,BL) : I_(x',y')
 * return:
 *   dir (AX) : {0-7}
 *     3 4 5
 *     2 X 6
 *     1 0 7
 */

extern  Cood  lines_dir_next(Cood pp, byte dir);
/*
 * ݍWƕp[^玟̍WZo
 *   (x,y) + dir{0-7} -> (x',y')
 * args:
 *   pp (AH,AL) : n_(x,y)
 *   dir(BL)    : {0-7}
 * return:
 *   np (AH,AL) : I_(x',y')
 */

extern  lines_minmax(Cood pp);
/*
 * ͂ꂽWɂAf[^̍őŏGAĐݒ肷
 * args:
 *   pp (AH,AL) : ͍W(x,y)
 */

extern  lines_eval();
/*
 * f[^̓]p[^(8byte)vZĐ[NɊi[
 */

#endif


/*
 *
 *   ̍WƓf[^̋L^Ɖ
 *
 */
struct _lines  lines;		/* f[^̊ǗƋL^[N */


extern
  lines_clear()
	 /* f[^̊ǗƋL^[N̏ */
{
	struct _lines  *lp = &lines;		/* f[^̊ǗƋL^[N */
	lp->count = 0;
	lp->mpn = 0;
}

extern
  lines_dir_culc(Cood pp, Cood np)
{
	static  char  dir[9] = { 3,-4,-3, 2,8,-2, 1,0,-1 };
	short p = 4;
	if (pp.b.x != np.b.x) {
		p -= 1;	if (pp.b.x < np.b.x) p += 2;
	}
	if (pp.b.y != np.b.y) {
		p -= 3;	if (pp.b.y < np.b.y) p += 6;
	}
	return dir[p];
}

extern  Cood
  lines_dir_next(Cood pp, byte dir)
{
	static char dx[8] = { 0,-1,-1,-1,0,1,1,1 };
	static char dy[8] = { 1,1,0,-1,-1,-1,0,1 };
	pp.b.x += dx[dir & 7];
	pp.b.y += dy[dir & 7];
	return pp;
}

extern 
  lines_minmax(Cood pp)
	/* f[^̍őŏGAi[ */
{
	struct _lines  *lp = &lines;		/* f[^̊ǗƋL^[N */
	if (pp.b.x < lp->min.b.x) lp->min.b.x = pp.b.x;
	else if (pp.b.x > lp->max.b.x) lp->max.b.x = pp.b.x;
	if (pp.b.y < lp->min.b.y) lp->min.b.y = pp.b.y;
	else if (pp.b.y > lp->max.b.y) lp->max.b.y = pp.b.y;
}

extern
  lines_eval()
	/* f[^̓o */
{
	struct _lines  *lp = &lines;		/* f[^̊ǗƋL^[N */
	short  c, p, s, w, wx, wy;

	{
		wx = lp->max.b.x-lp->min.b.x + 1;
		wy = lp->max.b.y-lp->min.b.y + 1;
		w = 4096 / (wx > wy ? wx : wy);
		wx = 4096 / wx;
		wy = 4096 / wy;
	}

	for (c = 0; c < lp->count; c++) {

		struct  _dots  *sp = &lp->seg[c];
		char  *dp = sp->dir;
		short  a;

		{
			short lx = (int)(sp->top.b.x - sp->ags.b.x) * wx / (16*16);
			short ly = (int)(sp->top.b.y - sp->ags.b.y) * wy / (16*16);
			if (lx < 0) lx = -lx;
			if (ly < 0) ly = -ly;

			sp->eval.lft = (lx >= ly ? lx : ly);
			sp->eval.len = (int)sp->n * w / (16*16);
			sp->eval.hx = (int)(sp->top.b.x - lp->min.b.x) * wx / (16*16);
			sp->eval.hy = (int)(sp->top.b.y - lp->min.b.y) * wy / (16*16);
		}

		a = 0;
		sp->eval.rot = 0;
		sp->eval.min = 0;
		sp->eval.max = 0;
		for (p = 0; p < sp->n; p++) {
			if (p > 0) {
				char dd = (*dp - *(dp-1)) & 7;
				dd |= (dd & 0x04 ? 0xfc : 0);
				sp->eval.rot += dd;
				if (sp->eval.rot < sp->eval.min) sp->eval.min = sp->eval.rot;
				if (sp->eval.rot > sp->eval.max) sp->eval.max = sp->eval.rot;
			}
			a += *dp++;
		}

		if ((a += (sp->n/2)) < 0)  a -= sp->n;
		sp->eval.dir = a / sp->n;
	}
}

