/*
 *    System Name : 菑͔FVXe
 *    Module Name : 菑̓{[h\
 *
 *       {[h̕`Ɛf[^̕\
 *
 *
 */
#include  "hand.h"

extern  unsigned short * Kanji_Font(unsigned short code);
/*  tHgAhX̎擾 */
extern  Kanji_Draw(short px, short py, unsigned short *font);
extern  Kanji_Draw_W(short px, short py, unsigned short *font);
/*  tHg̕` */

/*
 *
 *   ̓{[h̕\ƕ`搧
 *
 */

#define  BHX   0		/* ̓{[h HOME, WIDTH */
#define  BHY   0
#define  BWD   128

#define  EHX   128		/* o HOME, WIDTH */
#define  EHY   0
#define  EWD   32


extern  struct  win_position_proc win_pos_table[];

static  char  wel[][64] = {
	{	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x04,0xF0,0x21,0xB0,0x08,0x10,0x20,0x80,
		0x0B,0xFC,0xFB,0xF0,0x18,0x80,0x10,0x80,
		0x28,0xF8,0x23,0xF0,0x0A,0xA0,0x6A,0x90,
		0x0A,0x20,0x73,0xD0,0x0A,0xFC,0xAA,0x90,
		0x0A,0x20,0x23,0xD0,0x0A,0x50,0x22,0x90,
		0x08,0x88,0x22,0x90,0x09,0x0C,0x22,0xB0,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
	{	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x20,0x04,0x00,0x19,0x2C,0x02,0x00,
		0x04,0xA8,0x02,0x80,0x00,0x20,0x1F,0xC0,
		0x18,0xFC,0x02,0x00,0x04,0x84,0x02,0x20,
		0x00,0xFC,0x7F,0xF0,0x04,0x84,0x04,0x00,
		0x04,0xFC,0x08,0x80,0x08,0x84,0x10,0x40,
		0x09,0x84,0x37,0xE0,0x19,0x0C,0x38,0x30,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
	{	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0xC0,0x10,0x60,0x02,0x88,0x23,0xC0,
		0x1E,0xFC,0x48,0x20,0x02,0xD0,0x90,0xF0,
		0x03,0x50,0x27,0xC0,0x1E,0x50,0x60,0x40,
		0x12,0x30,0xA0,0x40,0x10,0x20,0x20,0x40,
		0x10,0x50,0x20,0x40,0x12,0x50,0x20,0x40,
		0x1F,0x88,0x20,0x40,0x00,0x0C,0x20,0xC0,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
	{	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x08,0x21,0xE0,0x03,0xFC,0x22,0x20,
		0x08,0x44,0xF8,0x40,0x0B,0x44,0x23,0xF0,
		0x0E,0x44,0x2A,0xD0,0x38,0x44,0x33,0x50,
		0x08,0x88,0x22,0x30,0x08,0x88,0xE0,0x80,
		0x0E,0x88,0xA7,0xF8,0x01,0x08,0x20,0xC0,
		0x00,0x50,0x61,0x20,0x00,0x30,0x26,0x18,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
};

board_icon_kouho(short hx, short hy)
{
	Kanji_Draw_W(hx, hy, (unsigned short *)wel[0]);
}
board_icon_shokyo(short hx, short hy)
{
	Kanji_Draw_W(hx, hy, (unsigned short *)wel[1]);
}
board_icon_kaigyo(short hx, short hy)
{
	Kanji_Draw_W(hx, hy, (unsigned short *)wel[2]);
}
board_icon_kirikae(short hx, short hy)
{
	Kanji_Draw_W(hx, hy, (unsigned short *)wel[3]);
}
board_make()
{
	LCood *home = &window_entry[_win_board].home;
	short  c;

	Box_Draw(home->w.x + BHX, home->w.y + BHY, BWD-1, BWD-1);
	board_icon_kouho(home->w.x + EHX, home->w.y + EHY);
	board_icon_shokyo(home->w.x + EHX, home->w.y + EHY + 16*7);
	board_icon_kaigyo(home->w.x + EHX, home->w.y + EHY + 16*9);
	board_icon_kirikae(home->w.x + EHX, home->w.y + EHY + 16*10);
	for (c = 0; c < 11; c++) {
		Box_Draw(home->w.x + EHX, home->w.y + EHY + c*16, EWD, 16);
	}
	Kanji_Draw(home->w.x + EHX, home->w.y + EHY + BWD, Kanji_Font(L'w'));
	Kanji_Draw(home->w.x + EHX+16, home->w.y + EHY + BWD, Kanji_Font(L'K'));

	board_preset_list();
}

board_draw_clear()
{
	LCood *home = &window_entry[_win_board].home;
	Box_Fill(home->w.x + BHX, home->w.y + BHY, BWD, BWD, 0);
	Box_Draw(home->w.x + BHX, home->w.y + BHY, BWD-1, BWD-1);
}
board_select_clear()
{
	LCood *home = &window_entry[_win_board].home;
	short  c;
	for (c = 1; c < 7; c++) {
		int hx = home->w.x + EHX;
		int hy = home->w.y + EHY + c * 16;
		Box_Fill(hx, hy, EWD, 16, 0);
		Box_Draw(hx, hy, EWD, 16);
		Kanji_Draw(hx, hy, Kanji_Font(L'@'));
		Kanji_Draw(hx+16, hy, Kanji_Font(L'@'));
	}
}


board_pset(Cood wp)
{
	LCood *home = &window_entry[_win_board].home;
	Dot_Draw(home->w.x + BHX + wp.b.x, home->w.y + BHY + wp.b.y);
}

board_preset(Cood wp)
{
	LCood *home = &window_entry[_win_board].home;
	Dot_Clear(home->w.x + BHX + wp.b.x, home->w.y + BHY + wp.b.y);
}


/*
 *
 *   ꗗo
 *
 */
extern  short board_out_count;
extern  word  board_out_list[12];

board_kanji_list_draw()
{
	LCood *home = &window_entry[_win_board].home;
	short  hx = home->w.x + EHX;
	short  hy = home->w.y + EHY + 16;
	short  c;

	for (c = 0; c < 6; c++) {
		Kanji_Draw(hx, hy, Kanji_Font(L'@'));
		Kanji_Draw(hx+16, hy, Kanji_Font(L'@'));
		if (c < board_out_count) {
			Kanji_Draw(hx + 8, hy, Kanji_Font(board_out_list[c]));
		}
		hy += 16;
	}
}


/*
 *
 *   ͉搔o
 *
 */

static  char  td[5][32] = {
	{	0x00,0x00,0x00,0x00,0x18,0x10,0x0F,0xF8,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
	{	0x00,0x00,0x00,0x00,0x18,0x10,0x0F,0xF8,
		0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
		0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
		0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
	{	0x00,0x00,0x00,0x00,0x18,0x10,0x0F,0xF8,
		0x01,0x00,0x01,0x00,0x01,0x00,0x01,0xE0,
		0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
		0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
	{	0x00,0x00,0x00,0x00,0x18,0x10,0x0F,0xF8,
		0x01,0x00,0x01,0x00,0x01,0x00,0x01,0xE0,
		0x19,0x00,0x09,0x00,0x09,0x00,0x09,0x00,
		0x09,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
	{	0x00,0x00,0x00,0x00,0x18,0x10,0x0F,0xF8,
		0x01,0x00,0x01,0x00,0x01,0x00,0x01,0xE0,
		0x19,0x00,0x09,0x00,0x09,0x00,0x09,0x00,
		0x6F,0xFC,0x38,0x06,0x00,0x00,0x00,0x00 }
};

	
board_tdout(short n)
{
	LCood *home = &window_entry[_win_board].home;
	short  p;

	n -= 1;
	for (p = EHY+16; n >= 5; p+=16)  n -= 5;

	Kanji_Draw(home->w.x + EHX, home->w.y + p, (unsigned short *)td[n]);
}

/*
 *
 *   vZbgo
 *
 */

extern  unsigned short  *preset_code[];
extern  short  preset_select;

board_preset_list()
{
	LCood *home = &window_entry[_win_board].home;
	short hx = home->w.x + BHX;
	short hy = home->w.y + BHY + BWD;
	unsigned short  *sp;
	short  l, c;

	for (l = 0; l < 3; l++) {
		if (l == 0) sp = preset_code[0];
		else if (l == 1) sp = preset_code[preset_select];

		for (c = 0; c < 8; c++) {
			Box_Draw(hx, hy, 16, 16);
			Kanji_Draw(hx, hy, Kanji_Font(*sp++));
			hx += 16;
		}
		hx -= 16*8;
		hy += 16;
	}
}

/*
 *
 *   eLXg̓{[h
 *
 */
#define	TWX	16
#define	TWY	16

extern  word  text_buffer[TWY*TWX];		/* eLXgobt@ */

text_make()
{
	LCood *home = &window_entry[_win_text].home;

	Box_Draw(home->w.x-8, home->w.y - 8, TWX * 16 + 16, TWY * 16 + 16);
	Box_Fill2(home->w.x, home->w.y, TWX * 16, TWY * 16, 0);

	{
		word  *tp = text_buffer;
		short  hx = home->w.x;
		short  hy = home->w.y;
		short  x, y;

		for (y = TWY; y != 0; y--) {
			for (x = TWX; x != 0; x--) {
				word c = *tp++;
				if (c) {
					Kanji_Draw(hx, hy, Kanji_Font(c));
				}
				hx += 16;
			}
			hx -= 16*TWX;
			hy += 16;
		}
	}
}

/*
 *
 *   ᐅ\
 *
 */

#define	_B_PUTC		(char)0x20
#define	_B_LOCATE	(char)0x23
#define	_B_DOWN		(char)0x27
#define	_B_LEFT		(char)0x29
#define _IOCSCALL  static inline
static	inline  int
  _IOCS(char no)
{
	register int res asm("d0");
	res = no;
	asm volatile("trap\t#15":"=g"(res):"g"(res));
	return res;
}
static	inline  int
  _IOCSd1(char no, int data)
{
	register int res asm("d0");
	register int d asm("d1");
	res = no;
	d = data;
	asm volatile("trap\t#15":"=g"(res):"g"(res),"g"(d));
	return res;
}
static	inline int
  _IOCSd12(char no, int d1, int d2)
{
	register int res asm("d0");
	register int r asm("d1");
	register int d asm("d2");
	res = no;
	r = d1;
	d = d2;
	asm volatile("trap\t#15":"=g"(res):"g"(res),"g"(r),"g"(d));
	return res;
}

_IOCSCALL	B_Putc (unsigned short code)	{return _IOCSd1(_B_PUTC,code);}
_IOCSCALL	B_Left (unsigned char  low)	{return _IOCSd1(_B_LEFT,low);}
_IOCSCALL	B_Down (unsigned char  low)	{return _IOCSd1(_B_DOWN,low);}
_IOCSCALL	B_Locate (short low, short column)	{return _IOCSd12(_B_LOCATE,low, column);}

/*
 *
 *   ̓{[h̕\ƕ`搧
 *
 */
_putchar(unsigned short code)
{
	B_Putc(code);
}
_locate(short x, short y)
{
	B_Locate(x,y);
}


_delete()
{
	B_Left(2);
	B_Putc(L'@');
	B_Left(2);
}
_cr()
{
	B_Left(-1);
	B_Down(0);
}
