/*
 *    System Name : 菑͔FVXe
 *    Module Name : 菑̓{[h
 *
 *       {[h̐Ɛf[^̓
 *
 *
 */
#include  "hand.h"


#ifdef AEgC
extern  board_init();
extern  board_recover();
	̓{[h̕\Ə
extern  board_in();

#endif



/*
 *
 *   ꗗo
 *
 */
static  short  backc = -1;

short board_out_count;
word  board_out_list[12];

board_kanji_list_make(short dkp)
{
	board_out_count = 0;
	{
		extern  word  match_code_list[8];
		word *code = match_code_list;
		short  wx = lines.max.b.x - lines.min.b.x;
		short  wy = lines.max.b.y - lines.min.b.y;
		short  small = ((wx > wy ? wx : wy) < 60);

		while (*code) {
			word  c = *code++;

			/* _ */
			if (dkp == 1) {
				if (!(c = hdk_adjust(c))) continue;
				board_out_list[board_out_count++] = c;

			/* _ */
			} else if (dkp == 2) {
				if (!(c = dk_adjust(c))) continue;
				board_out_list[board_out_count++] = c;

			/*  */
			} else if (small_adjust(c)) {
				if (small) {
					board_out_list[board_out_count++] = c - 1;
					board_out_list[board_out_count++] = c;
				} else {
					board_out_list[board_out_count++] = c;
					board_out_list[board_out_count++] = c - 1;
				}
			} else {
				board_out_list[board_out_count++] = c;
			}
		}
	}

	if (board_out_count == 0) {
		board_out_list[board_out_count++] = L'H';
	}

	backc = 0;
}


board_select_modify(short c)
{
	word nc = board_out_list[c];

	if (c >= board_out_count) return;

	if (c == backc) {
		edit_putchar(nc);

	} else {
		edit_modify(nc);
		backc = c;
	}
}

/*
 *  E_`FbN
 */
static  unsigned short  small_code[] = {
	L'',L'',L'',L'',L'',L'',L'',L'',L'',
	L'A',L'C',L'E',L'G',L'I',L'',L'',L'',L'c',0
  };
small_adjust(unsigned short code)
{
	unsigned short  *sp = small_code;
	while (*sp) {
		if (code == *sp) return -1;
		sp++;
	}
	return 0;
}

static  unsigned short  hdk_code[] = {
	L'',L'',L'',L'',L'',
	L'n',L'q',L't',L'w',L'z',0
  };
hdk_adjust(unsigned short code)
{
	unsigned short  *sp = hdk_code;
	/* printf("%4.4x ",code); */
	while (*sp) {
		if (code == *sp) return code + 2;
		sp++;
	}
	return 0;
}

static  unsigned short  dk_code[] = {
	L'',L'',L'',L'',L'',
	L'',L'',L'',L'',L'',
	L'',L'',L'',L'',L'',
	L'J',L'L',L'N',L'P',L'R',
	L'T',L'V',L'X',L'Z',L'\',
	L'^',L'`',L'c',L'e',L'g',
	L'',L'',L'',L'',L'',
	L'n',L'q',0x8374,L'w',L'z',0
  };
dk_adjust(unsigned short code)
{
	unsigned short  *sp = dk_code;
	while (*sp) {
		if (code == *sp) return code + 1;
		sp++;
	}
	if (code == L'E') return L'';
	return 0;
}



/*
 *
 *   vZbgo
 *
 */

static  unsigned short  preset_kigou1[] = {
	L'A',L'B',L'u',L'v',L'I',L'H',L'i',L'j'
  };
static  unsigned short  preset_kigou2[] = {
	L'E',L'V',L'X',L'`',L'c',L'',L'',L'',
	L'',L'',L'',L'',L'',L'~',L'{',L'|'
  };
static  unsigned short  preset_kanji1[] = {
	L'R',L'',L'J',L'C',L'X',L'u',L'',L'',
	L'',L'',L'',L'',L'A',L'',L'',L''
  };
static  unsigned short  preset_kanji2[] = {
	L'_',L'',L'R',L'',L'',L't',L'm',L'',
	L'',L'@',L'',L'l',L'@',L'@',L'@',L'@'
  };
static  unsigned short  preset_kanji3[] = {
	L'',L'',L'D',L'',L'H',L'',L'E',L'',
	L'',L'',L'',L'l',L'@',L'@',L'@',L'@'
  };

#define preset_max  5

unsigned short  *preset_code[preset_max] = {
	preset_kigou1,
	preset_kigou2,
	preset_kanji1,
	preset_kanji2,
	preset_kanji3,
};
short  preset_select = 1;


board_preset_out(short c)
{
	short code;

	if (c < 8)
	  code = preset_code[0][c];
	else
	  code = preset_code[preset_select][c-8];

	board_proc(BE_STR);
	edit_putchar(code);
}

board_cr()
{
	board_proc(BE_STR);
	edit_cr();
}

board_preset_change()
{
	if ((++preset_select) >= preset_max) {
		preset_select = 1;
	}
	board_preset_list();
}

/*
 *
 *	{[h \ wK
 *
 */
static  struct _lines  pre_lines;
#define  iskanji(c)  (((c)>=0x81 && (c)<=0x9f)||((c)>=0xe0 && (c)<=0xfc))

board_out()
{
	struct _lines *lp = &lines;
	short  dkp;

	if (lp->count == 0) return 0;

	/* f[^̕]lZo */
	lines_eval();
	/*printf("## segment [%d] dots %d\n", lp->count, lp->mpn);*/
	/*printf("\n");
	lines_dump(lp);*/

	dkp = match_dk_point();	/* _ / _ ] */
	if (dkp != 0) {
		lp->count -= dkp;
		lp->min = lp->seg[lp->count - 1].min;	/* ĕ] */
		lp->max = lp->seg[lp->count - 1].max;
		lines_eval();
	}

	match_analise();
	board_kanji_list_make(dkp);
	board_kanji_list_draw();

	pre_lines = lines;
	edit_putchar(board_out_list[0]);
	return -1;
}

board_educate()
{
	lines = pre_lines;
	match_educate(code_input());
	lines_clear();
}

/*
 *
 *	{[h 
 *
 */

extern  edit_putchar(short code);
extern  edit_modify(short code);
extern  edit_delete();

#ifdef ԑJ
 : 
     : ȂA͏
  ` : `́A搔\
   : `抮A\

Cxg :
#define	BE_PEN	0		/* y */
#define	BE_TOUT	1		/* ^C}[AEg */
#define	BE_SEL	2		/*  */
#define	BE_CAN	3		/*  */
#endif

static  short  board_stat;


bp_null_pen(short ax)
	 /*  -> y -> ` */
{
	board_stat = BS_DRAW;
}
bp_delete(short ax)
	 /*  ->  (GfB^ꕶ) */
{
	edit_delete();

	lines_clear();
}

bp_draw_select(short ax)
	 /* ` -> ^C}[AEg/ -> / */
{
	board_draw_clear();

	/* ^CAEgݒ 0 b */
	timer_clear(0);

	board_stat = (board_out() ? BS_SELC : BS_NULL);

	lines_clear();
}

bp_draw_cansel(short ax)
	 /* ` ->   ->  */
{
	board_draw_clear();
	board_select_clear();
	lines_clear();
	board_out_count = 0;

	/* ^CAEgݒ 1.5 b */
	/* timer_clear(0); */

	board_stat = BS_NULL;
}

bp_select_pen(short ax)
	 /*  -> y -> `(VK) */
{
	board_select_clear();
	board_out_count = 0;

	board_stat = BS_DRAW;
}

bp_retry(short ax)
	 /*  ->  ->  */
{
	board_select_clear();
	board_out_count = 0;

	edit_delete();

	/* ^CAEgݒ 1.5 b */
	/* timer_clear(0); */

	board_stat = BS_NULL;
}


static  int  (*board_event_proc[3][5])(short ax) = {
	/*    : ȂA͏ */
	{
		bp_null_pen,	/* y */
		0,				/* ^C}[AEg */
		0,				/*  */
		bp_delete,		/*  */
		0,				/* _CNgo */
	},

	/* ` : `́A搔\ */
	{
		0,	/* y */
		bp_draw_select,	/* ^C}[AEg */
		bp_draw_select,	/*  */
		bp_draw_cansel,	/*  */
		bp_draw_cansel,	/* _CNgo */
	},

	/*  : `抮A\ */
	{
		bp_select_pen,	/* y */
		0,				/* ^C}[AEg */
		0,				/*  */
		bp_retry,		/*  */
		bp_draw_cansel,		/* _CNgo */
	}
};	

extern
  board_init()
/*
 *   ̓{[hԏ
 */
{
	board_stat = BS_NULL;

	board_make();
	board_draw_clear();
	board_select_clear();
	board_out_count = 0;

	lines_clear();

	mouse_on();
}

extern
  board_recover()
/*
 *   ̓{[hI
 */
{
	mouse_off();
}

extern
  board_proc(short event)
/*
 *   ̓{[hԑJ
 */
{
	int (*proc)(short ax) = board_event_proc[board_stat][event];
	if (proc)  (*proc)(event);
}




/*
 *
 *	}EXhCo
 *
 */

_Pos_proc
  pen_board_push(Cood rp)
/*
 *  y̓{[h PUSH  (rp : }EX΍W)
 */
{
	/* ENbNȂ̓LZ */
	if (mouse_right_triger()) {
		board_proc(BE_CAN);

		/* ack == 1 : PUSH ̂ ړȂ */
		return 1;

	/* NbNȂ`X^[g */
	} else {
		pen_draw_start(rp);

		pen_control_pp = rp;
		pen_control_stat = PC_BOAD;

		/* ack == 0 : p */
		return 0;
	}
}

_Pos_proc
  pen_board_move(Cood rp)
/*
 *  y̓{[h MOVE  (rp : }EX΍W)
 */
{
	short  ack;
	if (!pen_control_trig) return 0;

	ack = pen_draw_move(pen_control_pp, rp);
	if (ack != 0) {
		return (ack > 0 ? ack : 0);

	} else {
		pen_control_pp = rp;
		return 0;
	}
}

_Pos_proc
  pen_select_push(Cood rp)
/*
 *  IGA PUSH  (rp : }EX΍W)
 */
{
	short  c;
	switch ((c = (rp.b.y / 16) + 1)) {
	  case 1 :
		board_proc(BE_SEL);
		break;
	  case 8 :
		board_proc(BE_CAN);
		break;
	  case 9 :
		board_educate();
		break;
	  case 10 :
		board_cr();
		break;
	  case 11 :
		board_preset_change();
		break;
	  default:
		board_select_modify(c-2);
	}

	pen_control_stat = PC_CMD;
		
	/* ack == 1 : PUSH ̂ ړȂ */
	return 1;
}

_Pos_proc
  pen_preset_push(Cood rp)
/*
 *  vZbgIGA PUSH  (rp : }EX΍W)
 */
{
	short  c = (rp.b.y / 16) * 8 + (rp.b.x / 16);

	board_preset_out(c);

	pen_control_stat = PC_STR;
		
	/* ack == 1 : PUSH ̂ ړȂ */
	return 1;
}



struct  win_position_proc board_window_proc[] = {
	{ {0,0}, {16,16}, pen_board_move, pen_board_push },
	{ {16,0}, {4,16+3*2}, _NOP, pen_select_push },
	{ {0,16}, {16,3*2}, _NOP, pen_preset_push },
	{ {0xff,0xff} }
};

