/*
 *    System Name : 菑͔FVXe
 *    Module Name : f[^r
 *
 *       f[^̓p[^̃e[ur
 *
 *
 */
#include  "hand.h"
/*#define  Verbose*/

#ifdef AEgC

  f[^̃}b`OTu[`
  ]lZo̊f[^}b`Ă
  R[he[u쐬

  match_analise();
  match_educate();
  match_dk_point();
  match_data_save();
  match_data_load();

extern  match_analise();
/*
 *  p^[}b`O
 *  ʂ word  match_code_list[8] Ɋi[
 */

extern  match_educate(word code);
/*
 *  p^[f[^wK
 *  O̐f[^ɊÂāAVR[hwK
 *  sƁAmatch_edit_flag  -1 ɂȂ
 * args:
 *   code (AX) : wKR[h
 */

extern  match_dk_point();
/*
 *  Xgɑ_A_Ă邩ǂ]
 *  return:
 *   dkp (AX) :  0 : _Ȃ  /  1 : _()  /  2 : _()
 *
 */

extern  match_data_save(char *buffer);
/*
 *  Xgf[^pbNāAbuffer ɃZ[u
 * args:
 *   buffer(AX): Z[uobt@
 *  return:
 *   size (AX) : f[^TCY(bytes)
 *
 */

extern  match_data_load(char *buffer);
/*
 *  Xgf[^ buffer 烍[h
 * args:
 *   buffer(AX): [hobt@
 *
 */

struct _eval {		/* f[^̕]l */
	char	dir;		/* 1 2 1 */
	char	rot;		/* 1 2 3 2 1 */
	char	min,max;	/* 1 2 3 2 1 */
	byte	hx,hy;
	byte	len,lft;
};

#endif


struct  _eval_table_n {
	word         code;
	struct _eval eval[0];
};



/*
 *   f[^̕]
 *
 */
static
  segment_eval(struct _eval *ref, struct _eval *etp)
{
	short value = 0;

	/* dir eval */
	{
		static short eval[8] = {4, 3, 0, 0, 0, 0, 0, 3};
		short  v = (ref->dir - etp->dir) & 7;
		value += eval[v];
#ifdef  Verbose
		printf("d(%d)",value);
#endif
	}

	/* rot/min/max eval */
	{
		static short eval[16] = {4, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3};
		short v = ref->rot - etp->rot;
		if (((v+8) & 127) < 16) value += eval[v & 15];
#ifdef  Verbose
		printf("r(%d)",value);
#endif
		v = ref->min - etp->min;
		if (((v+8) & 127) < 16) value += eval[v & 15];
#ifdef  Verbose
		printf("n(%d)",value);
#endif
		v = ref->max - etp->max;
		if (((v+8) & 127) < 16) value += eval[v & 15];
#ifdef  Verbose
		printf("m(%d)",value);
#endif
	}

	/* hx,hy,len eval */
	{
		static short eval[16] = {4, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3};
		short  v = (ref->hx - etp->hx) & 15;
		value += eval[v];
#ifdef  Verbose
		printf("x(%d)",value);
#endif
		v = (ref->hy - etp->hy) & 15;
		value += eval[v];
#ifdef  Verbose
		printf("y(%d)",value);
#endif
		v = ref->len - etp->len;
		if (((v+8) & 127) < 16) value += eval[v & 15];
#ifdef  Verbose
		printf("l(%d)",value);
#endif
		v = (ref->lft - etp->lft) & 15;
		value += eval[v];
	}

	return value;
}

static
  segment_ave(struct _eval *ref, struct _eval *etp)
{
	short v;

	v = ref->dir*3 + etp->dir + 2;
	etp->dir = (v < 0 ? v-3 : v)/4;
	v = ref->rot*3 + etp->rot + 2;
	etp->rot = (v < 0 ? v-3 : v)/4;
	v = ref->min*3 + etp->min + 2;
	etp->min = (v < 0 ? v-3 : v)/4;
	v = ref->max*3 + etp->max + 2;
	etp->max = (v < 0 ? v-3 : v)/4;

	v = ref->hx*3 + etp->hx + 2;
	etp->hx = (v < 0 ? v-3 : v)/4;
	v = ref->hy*3 + etp->hy + 2;
	etp->hy = (v < 0 ? v-3 : v)/4;
	v = ref->len*3 + etp->len + 2;
	etp->len = (v < 0 ? v-3 : v)/4;
	v = ref->lft*3 + etp->lft + 2;
	etp->lft = (v < 0 ? v-3 : v)/4;
}

static  segment_copy(struct _eval *ref, struct _eval *etp)
{
	*etp = *ref;
}


/*
 *
 *
 *
 */
static	short  table_ave = 0;
static	short  table_count  = 0;

struct  _eval_list {
	word  code;
	short value;
}   match_list[6];

word  match_code_list[8];

static
  match_list_init()
/*
 *  rXgf[^̏
 */
{
	struct  _eval_list *p = match_list;
	word   *cp = match_code_list;
	short  c;

	for (c = 6; c != 0; c--) {
		*cp++ = 0;
		p->value = 0;
		p++;
	}
	*cp++ = 0;
	*cp++ = 0;
}

static
  match_list_chain(short value, word code)
/*
 *  rXgڑ
 */
{
	short  c;
	struct  _eval_list *p = match_list;
	struct  _eval_list *q = p;
	short   v = p->value;

	for (c = 6; c != 0; c--) {
		if (p->value == 0) {
			q = p;
			break;
		} else if (p->value < v) {
			q = p;
			v = p->value;
		}
		p++;
	}
	
	if (q->value < value) {
		q->value = value;
		q->code = code;
	}
}


static
  match_list_sort()
/*
 * ]e[u̕ъ
 */
{
	short  c, f;
	struct  _eval_list *p;

	do {
		f = 0;
		p = match_list;
		for (c = 5; c != 0; c--) {
			if (p->value < (p+1)->value) {
				struct  _eval_list  w = *p;
				*p = *(p+1);
				*(p+1) = w;
				f = -1;
			}
			p++;
		}
	} while (f);
}

static
  match_list_get()
/*
 *  rXgf[^̎擾
 */
{
	short  c, th, n;
	struct  _eval_list *p;

	/* Xge[uɓ] */
	p = match_list;
	th = p->value - 6;
	n = 0;

	for (c = 0; c < 6; c++) {

		match_code_list[c] = 0;

		if (p->value >= th) {
			short  d;
			for (d = 0; d < n; d++) {
				if (match_code_list[d] == p->code) break;
			}
			if (d == n) {
				match_code_list[n++] = p->code;
	/*printf("[%c%c]",p->code>>8, p->code&255);
	printf("(%d)\n",p->value);*/

			}
		}
		p++;
	}

	return n;
}


static
  match_n_segment(struct _lines *lp, void *table, short seg)
/*
 *  Xgf[^Ƃ̎擾
 */
{
	struct  _eval_table_n  *etp = (struct  _eval_table_n *)table;

	table_ave = 0;
	table_count  = 0;
	match_list_init();

	/* e]l̎Zoƍőľo */
	while (etp->code) {
		short c;
		short val = 0;
#ifdef  Verbose
	printf("[%c%c][",etp->code>>8, etp->code&255);
#endif

		for (c = 0; c < seg; c++) {
			val += segment_eval(&lp->seg[c].eval, &etp->eval[c]);
		}

#ifdef  Verbose
	printf("][value %d]\n",val);
#endif

		match_list_chain(val, etp->code);

		table_ave += val;
		table_count++;
		etp = (struct _eval_table_n *)
		  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*seg);
	}

	match_list_sort();
	match_list_get();

	return table_count;
}




static
  match_update(struct  _eval_table_n *etp, short seg, struct _lines *lp)
{
	short c;
	for (c = 0; c < seg; c++) {
		segment_ave(&lp->seg[c].eval, &etp->eval[c]);
	}
}
static
  match_append(struct  _eval_table_n *etp, short seg, struct _lines *lp)
{
	short c;
	for (c = 0; c < seg; c++) {
		segment_copy(&lp->seg[c].eval, &etp->eval[c]);
	}
}

static
  match_n_educate(struct _lines *lp, void *table, short seg, word code)
/*
 *  Xgf[^̊wK
 */
{
	struct  _eval_table_n  *etp = (struct  _eval_table_n *)table;
	struct  _eval_table_n  *emp = etp;
	short  count;
	short  value;

	count  = 0;
	value  = 0;

	/* e]l̎Zoƍőľo */
	while (etp->code) {
		short c;
		short val = 0;

		if (etp->code == code) {
			for (c = 0; c < seg; c++) {
				val += segment_eval(&lp->seg[c].eval, &etp->eval[c]);
			}

			if (val > value) {
				value = val;
				emp = etp;
			}
			count++;
		}
		etp = (struct _eval_table_n *)
		  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*seg);
	}

	if (count != 0 && (long)value*3*table_count > (long)table_ave*4) {
		match_update(emp, seg, lp);
#ifdef  Verbose
printf("updated par\n");
#endif
	} else {
		etp->code = code;
		match_append(etp, seg, lp);
		etp = (struct _eval_table_n *)
		  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*seg);
		etp->code = 0;
#ifdef  Verbose
printf("appended par\n");
#endif
	}
}


/*
 *   f[^̕]le[u
 *
 */

/* 1 Segment */
struct  _eval_table_1 {
	word         code;
	struct _eval eval;
}		EVT1[128] = {
	{L'P', { 0, 0, 0, 0,    0, 0, 15,15 }},
	{ 0 }
};

	
/* 2 Segment */
struct  _eval_table_2 {
	word         code;
	struct _eval eval[2];
}		EVT2[256] = {
	{ 0 }
};


/* 3 Segment */
struct  _eval_table_3 {
	word         code;
	struct _eval eval[3];
}		EVT3[256] = {
	{L'S', {
	   {  1, 0, 0, 0,   14,0, 14,14 },
	   {  -2, 0, 0, 0,  0,14, 14,14 },
	   {  0, 0, 0, 0,   14,0, 14,14 }}},
	{ 0 }
};

struct  _eval_table_4 {
	word         code;
	struct _eval eval[4];
}		EVT4[256] = {
	{ 0 }
};

struct  _eval_table_5 {
	word         code;
	struct _eval eval[5];
}		EVT5[128] = {
	{ 0 }
};
struct  _eval_table_6 {
	word         code;
	struct _eval eval[6];
}		EVT6[128] = {
	{ 0 }
};
struct  _eval_table_7 {
	word         code;
	struct _eval eval[7];
}		EVT7[64] = {
	{ 0 }
};
struct  _eval_table_8 {
	word         code;
	struct _eval eval[8];
}		EVT8[64] = {
	{ 0 }
};
struct  _eval_table_9 {
	word         code;
	struct _eval eval[9];
}		EVT9[64] = {
	{ 0 }
};
struct  _eval_table_10 {
	word         code;
	struct _eval eval[10];
}		EVT10[64] = {
	{ 0 }
};
struct  _eval_table_11 {
	word         code;
	struct _eval eval[11];
}		EVT11[32] = {
	{ 0 }
};
struct  _eval_table_12 {
	word         code;
	struct _eval eval[12];
}		EVT12[32] = {
	{ 0 }
};
struct  _eval_table_13 {
	word         code;
	struct _eval eval[13];
}		EVT13[32] = {
	{ 0 }
};
struct  _eval_table_14 {
	word         code;
	struct _eval eval[14];
}		EVT14[32] = {
	{ 0 }
};
struct  _eval_table_15 {
	word         code;
	struct _eval eval[15];
}		EVT15[32] = {
	{ 0 }
};


/*
 *   f[^̕]Gg[
 *
 */
void  *match_table[] = {
	0,			/* dammy */
	(void*)EVT1,
	(void*)EVT2,
	(void*)EVT3,
	(void*)EVT4,
	(void*)EVT5,
	(void*)EVT6,
	(void*)EVT7,
	(void*)EVT8,
	(void*)EVT9,
	(void*)EVT10,
	(void*)EVT11,
	(void*)EVT12,
	(void*)EVT13,
	(void*)EVT14,
	(void*)EVT15,
  };

extern
  match_analise()
/*
 *  p^[}b`O
 */
{
	struct _lines *lp = &lines;
	void *table = match_table[lp->count];
	return match_n_segment(lp, table, lp->count);
}

short match_edit_flag = 0;

extern
  match_educate(word code)
/*
 *  p^[f[^wK
 */
{
	struct _lines *lp = &lines;
	void *table = match_table[lp->count];
	match_n_educate(lp, table, lp->count, code);
	match_edit_flag = -1;
}

extern
  match_dk_point()
/*
 *  Xg̑_A_]
 */
{
	struct _lines *lp = &lines;
	short  val;

	if (lp->count >= 3) {
		static  struct _eval eval1 = { 0,1,0,1, 12,0, 4,4 };
		static  struct _eval eval2 = { 0,1,0,1, 14,0, 4,4 };
		val = segment_eval(&lp->seg[lp->count-2].eval, &eval1);
		val += segment_eval(&lp->seg[lp->count-1].eval, &eval2);
		if (val >= 48) return 2;
	}
	if (lp->count >= 3) {
		static  struct _eval eval1 = { 0,-1,-1,1, 13,0, 3,4 };
		static  struct _eval eval2 = { 0,-1,-1,1, 14,0, 3,4 };
		val = segment_eval(&lp->seg[lp->count-2].eval, &eval1);
		val += segment_eval(&lp->seg[lp->count-1].eval, &eval2);
		if (val >= 48) return 2;
	}
	if (lp->count >= 2) {
		static  struct _eval eval = { -1,-7,-7,1, 13,1, 10,0 };
		val = segment_eval(&lp->seg[lp->count-1].eval, &eval);
		if (val >= 22) return 1;
	}
	if (lp->count >= 2) {
		static  struct _eval eval = { -1,7,-1,7, 13,4, 10,0 };
		val = segment_eval(&lp->seg[lp->count-1].eval, &eval);
		if (val >= 22) return 1;
	}

	return 0;
}



/*
 *
 *   }b`f[^ [hZ[u
 *
 */

extern
  match_data_save(char *buffer)
{
	short  j, n;
	struct  _eval_table_n  *etp;
	char *bp = buffer;

	for (n = 1; n <= 15; n++) {
		etp = (struct  _eval_table_n *)match_table[n];

		/* ZOgwb_[ */
		*bp++ = 'S';
		*bp++ = n;

		while (etp->code) {
			struct _eval *ref;
			/* R[h */
			*bp++ = 'L';
			*bp++ = etp->code >> 8;
			*bp++ = etp->code & 255;

			ref = etp->eval;
			for (j = 0; j < n; j++) {
				/* p[^ */
				*bp++ = 'D';
				*bp++ = ref->dir;
				*bp++ = ref->rot;
				*bp++ = ref->min;
				*bp++ = ref->max;
				*bp++ = ref->hx;
				*bp++ = ref->hy;
				*bp++ = ref->len;
				*bp++ = ref->lft;
				ref++;
			}
			etp = (struct _eval_table_n *)
			  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*n);
		}
	}
	*bp++ = 0;

	return (int)(bp - buffer);
}

extern
  match_data_load(char *buffer)
{
	short  n;
	struct  _eval_table_n  *etp;
	struct _eval *ref;
	char *bp = buffer;

	while (*bp) {
		switch(*bp++) {
		  case 'S' :
			n = *bp++;
			etp = (struct  _eval_table_n *)match_table[n];
			break;

		  case 'L' :
			{
				Cood c;
				c.b.x = *bp++;
				c.b.y = *bp++;
				etp->code = c.w;
			}
			ref = etp->eval;
			etp = (struct _eval_table_n *)
			  ((long)etp + sizeof(struct _eval_table_n) + sizeof(struct _eval)*n);
			break;

		  case 'D' :
			ref->dir = *bp++;
			ref->rot = *bp++;
			ref->min = *bp++;
			ref->max = *bp++;
			ref->hx = *bp++;
			ref->hy = *bp++;
			ref->len = *bp++;
			ref->lft = *bp++;
			ref++;
			break;
		}
	}
}

