/*
 *    System Name : 菑͔FVXe
 *    Module Name : 菑͕
 *
 *       f[^̓
 *
 *
 */
#include  "hand.h"

#ifdef AEgC
extern	mstat_init();
/*
 *  }EXړ]̏
 */
extern	mstat_vsync_proc();
/*
 *  }EXړ] (VSYNCN)
 */

#endif

/*
 *
 *	Mouse ړԑJ
 *
 */
#define  _mque_max  3

static  struct  mstat_control {
	short   stat;
	short	sum;
	short	*qpx;
	short	*qpy;
	LCood	dsum;
	LCood	dpre;
	short	mquex[_mque_max];
	short	mquey[_mque_max];
}		mstat_work;

/* mstat_control.stat */
#define _st_idle  0
#define _st_run   1


static	short	mstat_lock = -1;

volatile  LCood _mpos;

extern
  mstat_init()
/*
 *  }EXړ]̏
 */
{
	struct  mstat_control *mwp = &mstat_work;
	short  c;

	/* VSYNC jO֎~ */
	mstat_lock = -1;

	mwp->stat = _st_idle;

	/* L[X^bN */
	mwp->qpx = mwp->mquex;
	mwp->qpy = mwp->mquey;
	for (c = 0; c < _mque_max; c++) {
		*mwp->qpx++ = 0;
		*mwp->qpy++ = 0;
	}
	mwp->qpx = mwp->mquex;
	mwp->qpy = mwp->mquey;

	/* ]l  */
	mwp->sum = 0;
	mwp->dsum.w.x = 0;
	mwp->dsum.w.y = 0;

	/* VSYNC jOJ */
	mstat_lock = 0;
}


extern
  mstat_vsync_proc()
/*
 *  }EXړ] (VSYNCN)
 */
{
	struct  mstat_control *mwp = &mstat_work;
	extern  LCood  mouse_pos();
	static  LCood  bp;
	static  short  first = -1;
	short dx,dy;

	if (mstat_lock) return;

	_mpos = mouse_pos();
	if (first) {
		bp = _mpos;
		first = 0;
	}

	/* ϓxNǧvZ */
	dx = _mpos.w.x - bp.w.x;
	dy = _mpos.w.y - bp.w.y;
	{
		mwp->dsum.w.x -= *mwp->qpx;
		mwp->dsum.w.x += dx;
		*mwp->qpx++ = dx;
		if (mwp->qpx >= mwp->mquex + _mque_max)  mwp->qpx = mwp->mquex;

		mwp->dsum.w.y -= *mwp->qpy;
		mwp->dsum.w.y += dy;
		*mwp->qpy++ = dy;
		if (mwp->qpy >= mwp->mquey + _mque_max)  mwp->qpy = mwp->mquey;
	}

	/* ϓʂ̌vZ */
	{
		word  udx = (mwp->dsum.w.x >= 0 ? mwp->dsum.w.x : -mwp->dsum.w.x);
		word  udy = (mwp->dsum.w.y >= 0 ? mwp->dsum.w.y : -mwp->dsum.w.y);
		mwp->sum = (udx >= udy ? udx : udy);
	}

	/* ړ / ~ ԑJ */
	switch (mwp->stat) {
	  case _st_idle :
		if (mwp->sum > 2) {
			mwp->stat = _st_run;
		}
		break;

	  case _st_run :
		{
			word  udx = (dx >= 0 ? dx : -dx);
			word  udy = (dy >= 0 ? dy : -dy);
			short   len = (udx >= udy ? udx : udy);
			if (mwp->sum < 4 || len < mwp->sum/32) {
				mwp->stat = _st_idle;
			}
		}
		break;
	}

	bp = _mpos;
}


/*
 *
 *	{[h ́E`
 *
 */
static  short  pen_advantage;
static  char   dir[2048];		/* Wf[^̋L^[N */

pen_draw_start(Cood pp)
{
	struct _lines *lp = &lines;
	struct _dots *sp = &lp->seg[lp->count];
	struct  mstat_control *mwp = &mstat_work;

	sp->n = 0;
	sp->top = pp;	/* n_L^ */
	sp->dir = &dir[lp->mpn];

	/* MIN/MAX GAXV */
	if (lp->mpn == 0) {		/* ŏ̐̎n_Ȃ΂̍Wݒ */
		lp->min = pp;
		lp->max = pp;
	} else {		/* MIN/MAX GAXV */
		lines_minmax(pp);
	}

	/* }EXړ[h̒~`FbN */
	if (mwp->stat == _st_idle) {
		/* ~tO ON Ahoe[W */
		pen_advantage = -1;
		mwp->dpre.w.x = 0;
		mwp->dpre.w.y = 0;
	} else {
		pen_advantage = 0;
		mwp->dpre.w.x = mwp->dsum.w.x;
		mwp->dpre.w.y = mwp->dsum.w.y;
	}
		
	board_proc(BE_PEN);
}

pen_draw_move(Cood pp, Cood cp)
{
	struct _lines *lp = &lines;
	struct _dots *sp = &lp->seg[lp->count];
	struct  mstat_control *mwp = &mstat_work;

	/* }EXړ[h̒~`FbN */
	if (mwp->stat == _st_idle) {
		/* ~tO ON Ahoe[W */
		pen_advantage = -1;
		return -1;
	}

	/* ~̕AȂxNg`FbN */
	if (pen_advantage && !(mwp->dpre.w.x == 0 && mwp->dpre.w.y == 0)) {
		short ic = mwp->dsum.w.x * mwp->dpre.w.x + mwp->dsum.w.y * mwp->dpre.w.y;
		if (ic <= 0) return 2;
		/* ack == 2 : p Break `ē */
	}

	mwp->dpre.w.x = mwp->dsum.w.x;
	mwp->dpre.w.y = mwp->dsum.w.y;
	pen_advantage = 0;

	/* MIN/MAX GAXV */
	lines_minmax(cp);

	/* ̋L^ƕ` */
	{
		Cood wp = pp;
		while (wp.w != cp.w) {
			if (wp.b.x < cp.b.x) {
				wp.b.x++;
			} else if (wp.b.x > cp.b.x) {
				wp.b.x--;
			}
			
			if (wp.b.y < cp.b.y) {
				wp.b.y++;
			} else if (wp.b.y > cp.b.y) {
				wp.b.y--;
			}
			
			sp->dir[sp->n++] = lines_dir_culc(pp, wp);
			board_pset(wp);
			pp = wp;
		}
	}

	if (lp->mpn + sp->n >= 2000) return 1;	/* L^I[o[`FbN */
	/* ack == 1 : p Break `I */

	return 0;
}

pen_draw_close(Cood pp)
{
	struct _lines *lp = &lines;
	struct _dots *sp = &lp->seg[lp->count];

	sp->ags = pp;	/* I_L^ */

	/* S~(Z߂)͂˂ */
	if (sp->n >= 6) {
		/* ͈͂̋L^ */
		sp->min = lp->min;
		sp->max = lp->max;

		lp->count++;
		lp->mpn += sp->n;
		board_tdout(lp->count);

		/* L^I[o[`FbN */
		if (lp->count >= 16 || lp->mpn >= 1000) {
			board_proc(BE_SEL);
		}

		/*  */
	} else {
		short c;
		Cood  lp = sp->top;
		char  *dp = sp->dir;
		Cood  lines_dir_next(Cood pp, byte dir);

		for (c = 0; c <= sp->n; c++) {
			board_preset(lp);
			/*printf("%d,%d [%d]\n", lp.b.x, lp.b.y, *dp);*/
			lp = lines_dir_next(lp, *dp++);
		}
	}

	/* ^CAEgݒ 1.5 b */
	if (lp->count > 0) {
		timer_clear(90);
	}
}


/*
 *
 *	}EXhCo
 *
 */

byte	pen_control_trig;
byte	pen_control_stat;
Cood	pen_control_pp;

extern  struct  win_position_proc board_window_proc[];
extern  struct  win_position_proc text_window_proc[];

struct  win_position_entry window_entry[] = {
	{ {384,64}, board_window_proc },
	{ {16,64}, text_window_proc },
	{ {-1,-1} }
};

static
  pen_event_start(short event)
/*
 *  yCxg Jn
 */
{
	switch (event) {
	  case _wpp_push :
		pen_control_stat = PC_NULL;
		break;
	  /* case _wpp_idle :*/
	  /* case _wpp_left :*/
	}
}
static
  pen_event_else(short event)
/*
 *  yCxg I
 */
{
	switch (event) {
	  case _wpp_push :
		return 1;	/* ack == 1 : PUSH ̂ ړȂ */

	  case _wpp_move :
		if (pen_control_stat == PC_BOAD) {
			return 1;	/* ack == 1 : p Break `I */
		} else {
			return 0;
		}

	  /* case _wpp_idle :*/
	  /* case _wpp_left :*/
	  default:
		return 0;
	}
}

static
  pen_event_left()
/*
 *  y LEFT 
 */
{
	if (pen_control_stat == PC_BOAD) {
		pen_draw_close(pen_control_pp);
		return;

	} else {
		timer_clear(0);
	}
}


static LCood
  relative_pos(LCood pos, struct win_position_entry *wep)
/*
 *  Window ̑΍W
 */
{
	LCood  rp;
	short sx, sy;

	rp.l = 0;
	sx = _mpos.w.x - wep->home.w.x;
	if (sx < 0) return rp;

	sy = _mpos.w.y - wep->home.w.y;
	if (sy < 0) return rp;

	rp.w.x = sx;
	rp.w.y = sy;

	return rp;
}

static
  pen_event_proc(short event)
/*
 *  Window Gg[e[ǔƏs
 */
{
	extern  volatile  LCood _mpos;
	struct  win_position_entry *wep;

	/*  */
	pen_event_start(event);

	/* W s */
	for (wep = window_entry; wep->home.w.x != -1; wep++) {
		struct  win_position_proc *wpt = wep->table;
		LCood  rp = relative_pos(_mpos, wep);

		if (rp.l == 0)  continue;
		while (wpt->home.w != 0xffff) {
			Cood  p, r;
			p.b.x = (word)rp.w.x/8 - wpt->home.b.x;
			p.b.y = (word)rp.w.y/8 - wpt->home.b.y;

			if (p.b.x < wpt->size.b.x && p.b.y < wpt->size.b.y) {
				int (*proc)() = wpt->proc[event];
				if (proc) {
					r.b.x = rp.w.x - wpt->home.b.x*8;
					r.b.y = rp.w.y - wpt->home.b.y*8;
					return (*proc)(r);
				} else {
					break;
				}
			}
			wpt++;
		}
	}

	/* LGAȊȌ */
	return pen_event_else(event);
}
		

extern
  pen_drive()
/*
 *   }EX僋[vhCo[
 */
{

	/* ^CAEgݒ 0 b */
	timer_clear(0);

	for (;;) {
		short ack;

		/* J[\AChO */
		pen_control_trig = 0;
		while (!mouse_triger_on()) {

			/* J[\AChOԂ̏s */
			pen_event_proc(_wpp_idle);

			/* sTC (^CAEg) `FbN */
			if (timer_out()) {
				board_proc(BE_TOUT);	/* ^CAEgCxg */
			}

			/* I`FbN */
			if (escape()) {
				return 0;
			}
		}

		/* }EX LEFT NbN */
		{
			LCood pp = _mpos;

			/* J[\ gK[ ONԂ̏s */
			ack = pen_event_proc(_wpp_push);

			/* ack == 1 : PUSH ̂ ړȂ */
			if (ack == 1) {
				while (mouse_triger_on());
				continue;

			/* ack == 2 : [vI */
			} else if (ack == 2) {
				return 0;
			}

			/* J[\` */
			pen_control_trig = -1;
			while (mouse_triger_on()) {
				if (pp.l == _mpos.l) continue;		/* ړĂȂΌp҂ */

				ack = pen_event_proc(_wpp_move);

				/* ack == 1 : p Break (left CxgփXLbv)*/
				if (ack == 1) {
					while (mouse_triger_on());
					break;

				/* ack == 2 : [vEo (left CxgփXLbv) */
				} else if (ack == 2) {
					break;

				/* ack == 3 : [vEo (left CxgXLbv) */
				} else if (ack == 3) {
					break;
				}
			}
		}

		/* }EX LEFT J */
		if (ack <= 2) pen_event_left();

	}
}

